--- WARNING: THIS IS AN AUTO-GENERATED FILE, DO NOT EDIT. PLEASE MODIFY THE ORIGINAL SOURCE IN THE https://github.com/istio/istio REPO source_repo: https://github.com/istio/istio title: istioctl description: Istio control interface. generator: pkg-collateral-docs number_of_entries: 39 ---

Istio configuration command line utility for service operators to debug and diagnose their Istio mesh.

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl authn

A group of commands used to interact with Istio authentication policies. tls-check

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # Check whether TLS setting are matching between authentication policy and destination rules:
    istioctl authn tls-check

## istioctl authn tls-check

Check what authentication policies and destination rules pilot uses to config a proxy instance, and check if TLS settings are compatible between them.

    istioctl authn tls-check <pod-name[.namespace]> [<service>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # Check settings for pod "foo-656bd7df7c-5zp4s" in namespace default:
    istioctl authn tls-check foo-656bd7df7c-5zp4s.default

    # Check settings for pod "foo-656bd7df7c-5zp4s" in namespace default, filtered on destination
    service "bar" :
    istioctl authn tls-check foo-656bd7df7c-5zp4s.default bar

## istioctl deregister

De-registers a service instance

    istioctl deregister <svcname> <ip> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # de-register an endpoint 172.17.0.2 from service my-svc:
    istioctl deregister my-svc 172.17.0.2

## istioctl experimental

Experimental commands that may be modified or deprecated

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental auth

Commands to inspect and interact with the authentication (TLS, JWT) and authorization (RBAC) policies in the mesh check - check the TLS/JWT/RBAC settings based on the Envoy config upgrade - upgrade the authorization policy from version v1 to v2 validate - check for potential incorrect usage in authorization policy files.

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

      # Check the TLS/JWT/RBAC settings for pod httpbin-88ddbcfdd-nt5jb:
      istioctl experimental auth check httpbin-88ddbcfdd-nt5jb

## istioctl experimental auth check

Check analyzes the TLS/JWT/RBAC settings directly based on the Envoy config. The Envoy config could be provided either by pod name or from a config dump file (the whole output of http://localhost:15000/config_dump of an Envoy instance).

Currently only the listeners with node IP and clusters on outbound direction are analyzed: - listeners with node IP generally tell how should other pods talk to the Envoy instance which include the server side TLS/JWT/RBAC settings.

- clusters on outbound direction generally tell how should the Envoy instance talk to other pods which include the client side TLS settings.

To check the TLS setting, you could run 'check' on both of the client and server pods and compare the cluster results of the client pod and the listener results of the server pod.

To check the JWT/RBAC setting, you could run 'check' only on your server pods and check the listener results.

THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental auth check <pod-name>[.<pod-namespace>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--all` | `-a` | Show additional information (e.g. SNI and ALPN)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <string>` | `-f` | Check the TLS/JWT/RBAC setting from the config dump file (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

      # Check the TLS/JWT/RBAC policy status for pod httpbin-88ddbcfdd-nt5jb in namespace foo:
      istioctl experimental auth check httpbin-88ddbcfdd-nt5jb.foo

      # Check the TLS/JWT/RBAC policy status from a config dump file:
      istioctl experimental auth check -f httpbin_config_dump.txt

## istioctl experimental auth validate

This command goes through all authorization policy files and finds potential issues such as: * ServiceRoleBinding refers to a non existing ServiceRole. * ServiceRole not used. It does not require access to the cluster as the validation is against local files.

    istioctl experimental auth validate <policy-file1,policy-file2,...> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <stringSlice>` | `-f` | Authorization policy file (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental auth validate -f policy1.yaml,policy2.yaml

## istioctl experimental convert-ingress

Converts Ingresses into VirtualService configuration on a best effort basis. The output should be considered a starting point for your Istio configuration and probably require some minor modification. Warnings will be generated where configs cannot be converted perfectly. The input must be a Kubernetes Ingress. The conversion of v1alpha1 Istio rules has been removed from istioctl.

    istioctl experimental convert-ingress [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filenames <stringSlice>` | `-f` | Input filenames (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output filename (default `-`)

### Examples

    istioctl experimental convert-ingress -f samples/bookinfo/platform/kube/bookinfo-ingress.yaml

## istioctl experimental dashboard

Access to Istio web UIs

    istioctl experimental dashboard [flags]

    istioctl experimental dash [flags]
    istioctl experimental d [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental dashboard controlz

Open the ControlZ web UI for a pod in the Istio control plane

    istioctl experimental dashboard controlz <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--ctrlz_port <int>` |  | ControlZ port (default `9876`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental dashboard controlz pilot-123-456.istio-system

## istioctl experimental dashboard envoy

Open the Envoy admin dashboard for a sidecar

    istioctl experimental dashboard envoy <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental dashboard envoy productpage-123-456.default

## istioctl experimental dashboard grafana

Open Istio's Grafana dashboard

    istioctl experimental dashboard grafana [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental dashboard grafana

## istioctl experimental dashboard jaeger

Open Istio's Jaeger dashboard

    istioctl experimental dashboard jaeger [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental dashboard jaeger

## istioctl experimental dashboard kiali

Open Istio's Kiali dashboard

    istioctl experimental dashboard kiali [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental dashboard kiali

## istioctl experimental dashboard prometheus

Open Istio's Prometheus dashboard

    istioctl experimental dashboard prometheus [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental dashboard prometheus

## istioctl experimental dashboard zipkin

Open Istio's Zipkin dashboard

    istioctl experimental dashboard zipkin [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental dashboard zipkin

## istioctl experimental kube-uninject

kube-uninject is used to prevent Istio from adding a sidecar and also provides the inverse of "istioctl kube-inject -f".

    istioctl experimental kube-uninject [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <string>` | `-f` | Input Kubernetes resource filename (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Modified output Kubernetes resource filename (default ``)

### Examples

    # Update resources before applying.
    kubectl apply -f <(istioctl experimental kube-uninject -f <resource.yaml>)

    # Create a persistent version of the deployment by removing Envoy sidecar.
    istioctl experimental kube-uninject -f deployment.yaml -o deployment-uninjected.yaml

    # Update an existing deployment.
    kubectl get deployment -o yaml | istioctl experimental kube-uninject -f - | kubectl apply -f -

## istioctl experimental metrics

Prints the metrics for the specified service(s) when running in Kubernetes.

This command finds a Prometheus pod running in the specified istio system namespace. It then executes a series of queries per requested workload to find the following top-level workload metrics: total requests per second, error rate, and request latency at p50, p90, and p99 percentiles. The query results are printed to the console, organized by workload name.

All metrics returned are from server-side reports. This means that latencies and error rates are from the perspective of the service itself and not of an individual client (or aggregate set of clients). Rates and latencies are calculated over a time interval of 1 minute.

    istioctl experimental metrics <workload name>...

    istioctl experimental m <workload name>...

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # Retrieve workload metrics for productpage-v1 workload
    istioctl experimental metrics productpage-v1

    # Retrieve workload metrics for various services in the different namespaces
    istioctl experimental metrics productpage-v1.foo reviews-v1.bar ratings-v1.baz

## istioctl kube-inject

kube-inject manually injects the Envoy sidecar into Kubernetes workloads. Unsupported resources are left unmodified so it is safe to run kube-inject over a single file that contains multiple Service, ConfigMap, Deployment, etc. definitions for a complex application. It's best to do this when the resource is initially created.

k8s.io/docs/concepts/workloads/pods/pod-overview/#pod-templates is updated for Job, DaemonSet, ReplicaSet, Pod and Deployment YAML resource documents. Support for additional pod-based resource types can be added as necessary.

The Istio project is continually evolving so the Istio sidecar configuration may change unannounced. When in doubt re-run istioctl kube-inject on deployments to get the most up-to-date changes.

    istioctl kube-inject [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <string>` | `-f` | Input Kubernetes resource filename (default ``)
`--injectConfigFile <string>` |  | injection configuration filename. Cannot be used with --injectConfigMapName (default ``)
`--injectConfigMapName <string>` |  | ConfigMap name for Istio sidecar injection, key should be "config". (default `istio-sidecar-injector`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--meshConfigFile <string>` |  | mesh configuration filename. Takes precedence over --meshConfigMapName if set (default ``)
`--meshConfigMapName <string>` |  | ConfigMap name for Istio mesh configuration, key should be "mesh" (default `istio`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Modified output Kubernetes resource filename (default ``)
`--valuesFile <string>` |  | injection values configuration filename. (default ``)

### Examples

    # Update resources on the fly before applying.
    kubectl apply -f <(istioctl kube-inject -f <resource.yaml>)

    # Create a persistent version of the deployment with Envoy sidecar
    # injected.
    istioctl kube-inject -f deployment.yaml -o deployment-injected.yaml

    # Update an existing deployment.
    kubectl get deployment -o yaml | istioctl kube-inject -f - | kubectl apply -f -

    # Capture cluster configuration for later use with kube-inject
    kubectl -n istio-system get cm istio-sidecar-injector  -o jsonpath="{.data.config}" > /tmp/inj-template.tmpl
    kubectl -n istio-system get cm istio -o jsonpath="{.data.mesh}" > /tmp/mesh.yaml
    kubectl -n istio-system get cm istio-sidecar-injector -o jsonpath="{.data.values}" > /tmp/values.json
    # Use kube-inject based on captured configuration
    istioctl kube-inject -f samples/bookinfo/platform/kube/bookinfo.yaml \
    	--injectConfigFile /tmp/inj-template.tmpl \
    	--meshConfigFile /tmp/mesh.yaml \
    	--valuesFile /tmp/values.json

## istioctl proxy-config

A group of commands used to retrieve information about proxy configuration from the Envoy config dump

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)

### Examples

      # Retrieve information about proxy configuration from an Envoy instance.
      istioctl proxy-config <clusters|listeners|routes|endpoints|bootstrap> <pod-name[.namespace]>

## istioctl proxy-config bootstrap

Retrieve information about bootstrap configuration for the Envoy instance in the specified pod.

    istioctl proxy-config bootstrap <pod-name[.namespace]> [flags]

    istioctl proxy-config b <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)

### Examples

      # Retrieve full bootstrap configuration for a given pod from Envoy.
      istioctl proxy-config bootstrap <pod-name[.namespace]>

## istioctl proxy-config cluster

Retrieve information about cluster configuration for the Envoy instance in the specified pod.

    istioctl proxy-config cluster <pod-name[.namespace]> [flags]

    istioctl proxy-config clusters <pod-name[.namespace]> [flags]
    istioctl proxy-config c <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--direction <string>` |  | Filter clusters by Direction field (default ``)
`--fqdn <string>` |  | Filter clusters by substring of Service FQDN field (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--port <int>` |  | Filter clusters by Port field (default `0`)
`--subset <string>` |  | Filter clusters by substring of Subset field (default ``)

### Examples

      # Retrieve summary about cluster configuration for a given pod from Envoy.
      istioctl proxy-config clusters <pod-name[.namespace]>

      # Retrieve cluster summary for clusters with port 9080.
      istioctl proxy-config clusters <pod-name[.namespace]> --port 9080

      # Retrieve full cluster dump for clusters that are inbound with a FQDN of details.default.svc.cluster.local.
      istioctl proxy-config clusters <pod-name[.namespace]> --fqdn details.default.svc.cluster.local --direction inbound -o json

## istioctl proxy-config endpoint

Retrieve information about endpoint configuration for the Envoy instance in the specified pod.

    istioctl proxy-config endpoint <pod-name[.namespace]> [flags]

    istioctl proxy-config endpoints <pod-name[.namespace]> [flags]
    istioctl proxy-config ep <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--address <string>` |  | Filter endpoints by address field (default ``)
`--cluster <string>` |  | Filter endpoints by cluster name field (default ``)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--port <int>` |  | Filter endpoints by Port field (default `0`)
`--status <string>` |  | Filter endpoints by status field (default ``)

### Examples

      # Retrieve full endpoint configuration for a given pod from Envoy.
      istioctl proxy-config endpoint <pod-name[.namespace]>

      # Retrieve endpoint summary for endpoint with port 9080.
      istioctl proxy-config endpoint <pod-name[.namespace]> --port 9080

      # Retrieve full endpoint with a address (172.17.0.2).
      istioctl proxy-config endpoint <pod-name[.namespace]> --address 172.17.0.2 -o json

      # Retrieve full endpoint with a cluster name (outbound|9411||zipkin.istio-system.svc.cluster.local).
      istioctl proxy-config endpoint <pod-name[.namespace]> --cluster "outbound|9411||zipkin.istio-system.svc.cluster.local" -o json
      # Retrieve full endpoint with the status (healthy).
      istioctl proxy-config endpoint <pod-name[.namespace]> --status healthy -ojson

## istioctl proxy-config listener

Retrieve information about listener configuration for the Envoy instance in the specified pod.

    istioctl proxy-config listener <pod-name[.namespace]> [flags]

    istioctl proxy-config listeners <pod-name[.namespace]> [flags]
    istioctl proxy-config l <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--address <string>` |  | Filter listeners by address field (default ``)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--port <int>` |  | Filter listeners by Port field (default `0`)
`--type <string>` |  | Filter listeners by type field (default ``)

### Examples

      # Retrieve summary about listener configuration for a given pod from Envoy.
      istioctl proxy-config listeners <pod-name[.namespace]>

      # Retrieve listener summary for listeners with port 9080.
      istioctl proxy-config listeners <pod-name[.namespace]> --port 9080

      # Retrieve full listener dump for HTTP listeners with a wildcard address (0.0.0.0).
      istioctl proxy-config listeners <pod-name[.namespace]> --type HTTP --address 0.0.0.0 -o json

## istioctl proxy-config route

Retrieve information about route configuration for the Envoy instance in the specified pod.

    istioctl proxy-config route <pod-name[.namespace]> [flags]

    istioctl proxy-config routes <pod-name[.namespace]> [flags]
    istioctl proxy-config r <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--name <string>` |  | Filter listeners by route name field (default ``)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)

### Examples

      # Retrieve summary about route configuration for a given pod from Envoy.
      istioctl proxy-config routes <pod-name[.namespace]>

      # Retrieve route summary for route 9080.
      istioctl proxy-config route <pod-name[.namespace]> --name 9080

      # Retrieve full route dump for route 9080
      istioctl proxy-config route <pod-name[.namespace]> --name 9080 -o json

## istioctl proxy-status

Retrieves last sent and last acknowledged xDS sync from Pilot to each Envoy in the mesh

    istioctl proxy-status [<pod-name[.namespace]>] [flags]

    istioctl ps [<pod-name[.namespace]>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # Retrieve sync status for all Envoys in a mesh
    	istioctl proxy-status

    # Retrieve sync diff for a single Envoy and Pilot
    	istioctl proxy-status istio-egressgateway-59585c5b9c-ndc59.istio-system

## istioctl register

Registers a service instance (e.g. VM) joining the mesh

    istioctl register <svcname> <ip> [name1:]port1 [name2:]port2 ... [flags]

Flags | Shorthand | Description
--- | --- | ---
`--annotations <stringSlice>` | `-a` | List of string annotations to apply if creating a service/endpoint; e.g. -a foo=bar,test,x=y (default `[]`)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--labels <stringSlice>` | `-l` | List of labels to apply if creating a service/endpoint; e.g. -l env=prod,vers=2 (default `[]`)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--serviceaccount <string>` | `-s` | Service account to link to the service (default `default`)

## istioctl validate

Validate Istio policy and rules

    istioctl validate -f FILENAME [options] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <stringSlice>` | `-f` | Names of files to validate (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--referential` | `-x` | Enable structural validation for policy and telemetry

### Examples

    		# Validate bookinfo-gateway.yaml
    		istioctl validate -f bookinfo-gateway.yaml

    		# Validate current deployments under 'default' namespace within the cluster
    		kubectl get deployments -o yaml |istioctl validate -f -

    		# Validate current services under 'default' namespace within the cluster
    		kubectl get services -o yaml |istioctl validate -f -

## istioctl verify-install

verify-install verifies Istio installation status against the installation file you specified when you installed Istio. It loops through all the installation resources defined in your installation file and reports whether all of them are in ready status. It will report failure when any of them are not ready.

If you do not specify installation file it will perform pre-check for your cluster and report whether the cluster is ready for Istio installation.

    istioctl verify-install [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--enableVerbose` |  | Enable verbose output
`--filename <stringSlice>` | `-f` | Istio YAML installation file. (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--recursive` | `-R` | Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

### Examples

    		# Verify that Istio can be freshly installed
    		istioctl verify-install

    		# Verify that the deployment matches the istio-demo profile
    		istioctl verify-install -f istio-demo.yaml

    		# Verify the deployment matches a custom Istio deployment configuration
    		istioctl verify-install -f $HOME/istio.yaml

## istioctl version

Prints out build version information

    istioctl version [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, attributes, authn, default, grpcAdapter, kube-converter, mcp, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | One of 'yaml' or 'json'. (default ``)
`--remote` |  | Use --remote=false to suppress control plane check
`--short` | `-s` | Use --short=false to generate full version information

## Environment variables

These environment variables affect the behavior of the `istioctl` command.

Variable Name | Type | Default Value | Description
--- | --- | --- | ---
`BYPASS_OOP_MTLS_SAN_VERIFICATION` | Boolean | `false` | Whether or not to validate SANs for out-of-process adapters auth.
`ISTIO_GPRC_MAXSTREAMS` | Integer | `100000` | Sets the maximum number of concurrent grpc streams.
`ISTIO_LANG` | String | `` | Selects the attribute expression langauge runtime for Mixer.
`K8S_INGRESS_NS` | String | `` |
`PILOT_CERT_DIR` | String | `` |
`PILOT_DEBOUNCE_AFTER` | Time Duration | `100ms` | The delay added to config/registry events for debouncing. This will delay the push by at least this internal. If no change is detected within this period, the push will happen, otherwise we'll keep delaying until things settle, up to a max of PILOT_DEBOUNCE_MAX.
`PILOT_DEBOUNCE_MAX` | Time Duration | `10s` | The maximum amount of time to wait for events while debouncing. If events keep showing up with no breaks for this time, we'll trigger a push.
`PILOT_DEBUG_ADSZ_CONFIG` | Boolean | `false` |
`PILOT_DISABLE_XDS_MARSHALING_TO_ANY` | Boolean | `false` |
`PILOT_ENABLE_FALLTHROUGH_ROUTE` | Boolean | `true` | EnableFallthroughRoute provides an option to add a final wildcard match for routes. When ALLOW_ANY traffic policy is used, a Passthrough cluster is used. When REGISTRY_ONLY traffic policy is used, a 502 error is returned.
`PILOT_ENABLE_MYSQL_FILTER` | Boolean | `false` | EnableMysqlFilter enables injection of `envoy.filters.network.mysql_proxy` in the filter chain.
`PILOT_ENABLE_REDIS_FILTER` | Boolean | `false` | EnableRedisFilter enables injection of `envoy.filters.network.redis_proxy` in the filter chain.
`PILOT_HTTP10` | Boolean | `false` | Enables the use of HTTP 1.0 in the outbound HTTP listeners, to support legacy applications.
`PILOT_INITIAL_FETCH_TIMEOUT` | Time Duration | `0s` | Specifies the initial_fetch_timeout for config. If this time is reached without a response to the config requested by Envoy, the Envoy will move on with the init phase. This prevents envoy from getting stuck waiting on config during startup.
`PILOT_PUSH_THROTTLE` | Integer | `100` | Limits the number of concurrent pushes allowed. On larger machines this can be increased for faster pushes
`PILOT_RESTRICT_POD_UP_TRAFFIC_LOOP` | Boolean | `true` | If enabled, this will block inbound traffic from matching outbound listeners, which could result in an infinite loop of traffic. This option is only provided for backward compatibility purposes and will be removed in the near future.
`PILOT_SCOPE_PUSHES` | Boolean | `true` | If enabled, pilot will attempt to limit unnecessary pushes by determining what proxies a config or endpoint update will impact.
`PILOT_SIDECAR_USE_REMOTE_ADDRESS` | Boolean | `false` | UseRemoteAddress sets useRemoteAddress to true for side car outbound listeners.
`PILOT_TRACE_SAMPLING` | Floating-Point | `100` | Sets the mesh-wide trace sampling percentage. Should be 0.0 - 100.0. Precision to 0.01. Default is 100, not recommended for production use.
`POD_NAME` | String | `` |
`TERMINATION_DRAIN_DURATION_SECONDS` | Integer | `5` | The amount of time allowed for connections to complete on pilot-agent shutdown. On receiving SIGTERM or SIGINT, pilot-agent tells the active Envoy to start draining, preventing any new connections and allowing existing connections to complete. It then sleeps for the TerminationDrainDuration and then kills any remaining active Envoy processes.
`USE_ISTIO_JWT_FILTER` | Boolean | `false` | Use the Istio JWT filter for JWT token verification.
`V2_REFRESH` | Time Duration | `0s` |

## Exported metrics

Metric Name | Type | Description
--- | --- | ---
`endpoint_no_pod` | `LastValue` | Endpoints without an associated pod.
`mixer_config_adapter_info_config_errors_total` | `LastValue` | The number of errors encountered during processing of the adapter info configuration.
`mixer_config_adapter_info_configs_total` | `LastValue` | The number of known adapters in the current config.
`mixer_config_attributes_total` | `LastValue` | The number of known attributes in the current config.
`mixer_config_handler_configs_total` | `LastValue` | The number of known handlers in the current config.
`mixer_config_handler_validation_error_total` | `LastValue` | The number of errors encountered because handler validation returned error.
`mixer_config_instance_config_errors_total` | `LastValue` | The number of errors encountered during processing of the instance configuration.
`mixer_config_instance_configs_total` | `LastValue` | The number of known instances in the current config.
`mixer_config_rule_config_errors_total` | `LastValue` | The number of errors encountered during processing of the rule configuration.
`mixer_config_rule_config_match_error_total` | `LastValue` | The number of rule conditions that was not parseable.
`mixer_config_rule_configs_total` | `LastValue` | The number of known rules in the current config.
`mixer_config_template_config_errors_total` | `LastValue` | The number of errors encountered during processing of the template configuration.
`mixer_config_template_configs_total` | `LastValue` | The number of known templates in the current config.
`mixer_config_unsatisfied_action_handler_total` | `LastValue` | The number of actions that failed due to handlers being unavailable.
`mixer_dispatcher_destinations_per_request` | `Distribution` | Number of handlers dispatched per request by Mixer
`mixer_dispatcher_destinations_per_variety_total` | `LastValue` | Number of Mixer adapter destinations by template variety type
`mixer_dispatcher_instances_per_request` | `Distribution` | Number of instances created per request by Mixer
`mixer_handler_closed_handlers_total` | `LastValue` | The number of handlers that were closed during config transition.
`mixer_handler_daemons_total` | `LastValue` | The current number of active daemon routines in a given adapter environment.
`mixer_handler_handler_build_failures_total` | `LastValue` | The number of handlers that failed creation during config transition.
`mixer_handler_handler_close_failures_total` | `LastValue` | The number of errors encountered while closing handlers during config transition.
`mixer_handler_new_handlers_total` | `LastValue` | The number of handlers that were newly created during config transition.
`mixer_handler_reused_handlers_total` | `LastValue` | The number of handlers that were re-used during config transition.
`mixer_handler_workers_total` | `LastValue` | The current number of active worker routines in a given adapter environment.
`mixer_runtime_dispatch_duration_seconds` | `Distribution` | Duration in seconds for adapter dispatches handled by Mixer.
`mixer_runtime_dispatches_total` | `Count` | Total number of adapter dispatches handled by Mixer.
`pilot_conflict_inbound_listener` | `LastValue` | Number of conflicting inbound listeners.
`pilot_conflict_outbound_listener_http_over_current_tcp` | `LastValue` | Number of conflicting wildcard http listeners with current wildcard tcp listener.
`pilot_conflict_outbound_listener_tcp_over_current_http` | `LastValue` | Number of conflicting wildcard tcp listeners with current wildcard http listener.
`pilot_conflict_outbound_listener_tcp_over_current_tcp` | `LastValue` | Number of conflicting tcp listeners with current tcp listener.
`pilot_destrule_subsets` | `LastValue` | Duplicate subsets across destination rules for same host
`pilot_duplicate_envoy_clusters` | `LastValue` | Duplicate envoy clusters caused by service entries with same hostname
`pilot_eds_no_instances` | `LastValue` | Number of clusters without instances.
`pilot_endpoint_not_ready` | `LastValue` | Endpoint found in unready state.
`pilot_inbound_updates` | `Sum` | Total number of updates received by pilot.
`pilot_invalid_out_listeners` | `LastValue` | Number of invalid outbound listeners.
`pilot_jwks_resolver_network_fetch_fail_total` | `Sum` | Total number of failed network fetch by pilot jwks resolver
`pilot_jwks_resolver_network_fetch_success_total` | `Sum` | Total number of successfully network fetch by pilot jwks resolver
`pilot_k8s_cfg_events` | `Sum` | Events from k8s config.
`pilot_k8s_object_errors` | `LastValue` | Errors converting k8s CRDs
`pilot_k8s_reg_events` | `Sum` | Events from k8s registry.
`pilot_no_ip` | `LastValue` | Pods not found in the endpoint table, possibly invalid.
`pilot_proxy_convergence_time` | `Distribution` | Delay between config change and all proxies converging.
`pilot_proxy_queue_time` | `Distribution` | Time a proxy is in the push queue before being dequeued.
`pilot_rds_expired_nonce` | `Sum` | Total number of RDS messages with an expired nonce.
`pilot_services` | `LastValue` | Total services known to pilot.
`pilot_total_rejected_configs` | `Sum` | Total number of configs that Pilot had to reject or ignore.
`pilot_total_xds_internal_errors` | `Sum` | Total number of internal XDS errors in pilot.
`pilot_total_xds_rejects` | `Sum` | Total number of XDS responses from pilot rejected by proxy.
`pilot_virt_services` | `LastValue` | Total virtual services known to pilot.
`pilot_vservice_dup_domain` | `LastValue` | Virtual services with dup domains.
`pilot_xds` | `LastValue` | Number of endpoints connected to this pilot using XDS.
`pilot_xds_cds_reject` | `LastValue` | Pilot rejected CSD configs.
`pilot_xds_eds_instances` | `LastValue` | Instances for each cluster, as of last push. Zero instances is an error.
`pilot_xds_eds_reject` | `LastValue` | Pilot rejected EDS.
`pilot_xds_lds_reject` | `LastValue` | Pilot rejected LDS.
`pilot_xds_push_context_errors` | `Sum` | Number of errors (timeouts) initiating push context.
`pilot_xds_pushes` | `Sum` | Pilot build and send errors for lds, rds, cds and eds.
`pilot_xds_rds_reject` | `LastValue` | Pilot rejected RDS.
`pilot_xds_write_timeout` | `Sum` | Pilot XDS response write timeouts.